.text
// Copyright 2009-2016 The OpenSSL Project Authors. All Rights Reserved.
//
// Licensed under the OpenSSL license (the "License").  You may not use
// this file except in compliance with the License.  You can obtain a copy
// in the file LICENSE in the source distribution or at
// https://www.openssl.org/source/license.html

.globl	OPENSSL_s390x_facilities
.type	OPENSSL_s390x_facilities,@function
.align	16
OPENSSL_s390x_facilities:
	lghi	%r0,0
	larl	%r4,OPENSSL_s390xcap_P
	stg	%r0,8(%r4)	# wipe capability vectors
	stg	%r0,16(%r4)
	stg	%r0,24(%r4)
	stg	%r0,32(%r4)
	stg	%r0,40(%r4)
	stg	%r0,48(%r4)
	stg	%r0,56(%r4)
	stg	%r0,64(%r4)
	stg	%r0,72(%r4)
	stg	%r0,80(%r4)
	stg	%r0,88(%r4)
	stg	%r0,96(%r4)
	stg	%r0,104(%r4)
	stg	%r0,112(%r4)
	stg	%r0,120(%r4)
	stg	%r0,128(%r4)
	stg	%r0,136(%r4)
	stg	%r0,144(%r4)
	stg	%r0,152(%r4)
	stg	%r0,160(%r4)

	.long	0xb2b04000	# stfle	0(%r4)
	brc	8,.Ldone
	lghi	%r0,1
	.long	0xb2b04000	# stfle 0(%r4)
	brc	8,.Ldone
	lghi	%r0,2
	.long	0xb2b04000	# stfle 0(%r4)
.Ldone:
	lmg	%r2,%r3,0(%r4)
	tmhl	%r2,0x4000	# check for message-security-assist
	jz	.Lret

	lghi	%r0,0		# query kimd capabilities
	la	%r1,24(%r4)
	.long	0xb93e0002	# kimd %r0,%r2

	lghi	%r0,0		# query km capability vector
	la	%r1,40(%r4)
	.long	0xb92e0042	# km %r4,%r2

	lghi	%r0,0		# query kmc capability vector
	la	%r1,56(%r4)
	.long	0xb92f0042	# kmc %r4,%r2

	lghi	%r0,0		# query kmac capability vector
	la	%r1,72(%r4)
	.long	0xb91e0042	# kmac %r4,%r2

	tmhh	%r3,0x0004	# check for message-security-assist-4
	jz	.Lret

	lghi	%r0,0		# query kmctr capability vector
	la	%r1,88(%r4)
	.long	0xb92d2042	# kmctr %r4,%r2,%r2

	lghi	%r0,0		# query kmo capability vector
	la	%r1,104(%r4)
	.long	0xb92b0042	# kmo %r4,%r2

	lghi	%r0,0		# query kmf capability vector
	la	%r1,120(%r4)
	.long	0xb92a0042	# kmf %r4,%r2

	tml	%r2,0x40	# check for message-security-assist-5
	jz	.Lret

	lghi	%r0,0		# query prno capability vector
	la	%r1,136(%r4)
	.long	0xb93c0042	# prno %r4,%r2

	lg	%r2,16(%r4)
	tmhl	%r2,0x2000	# check for message-security-assist-8
	jz	.Lret

	lghi	%r0,0		# query kma capability vector
	la	%r1,152(%r4)
	.long	0xb9294022	# kma %r2,%r4,%r2

.Lret:
	br	%r14
.size	OPENSSL_s390x_facilities,.-OPENSSL_s390x_facilities

.globl	OPENSSL_rdtsc
.type	OPENSSL_rdtsc,@function
.align	16
OPENSSL_rdtsc:
	stck	16(%r15)
	lg	%r2,16(%r15)
	br	%r14
.size	OPENSSL_rdtsc,.-OPENSSL_rdtsc

.globl	OPENSSL_atomic_add
.type	OPENSSL_atomic_add,@function
.align	16
OPENSSL_atomic_add:
	l	%r1,0(%r2)
.Lspin:	lr	%r0,%r1
	ar	%r0,%r3
	cs	%r1,%r0,0(%r2)
	brc	4,.Lspin
	lgfr	%r2,%r0		# OpenSSL expects the new value
	br	%r14
.size	OPENSSL_atomic_add,.-OPENSSL_atomic_add

.globl	OPENSSL_wipe_cpu
.type	OPENSSL_wipe_cpu,@function
.align	16
OPENSSL_wipe_cpu:
	xgr	%r0,%r0
	xgr	%r1,%r1
	lgr	%r2,%r15
	xgr	%r3,%r3
	xgr	%r4,%r4
	lzdr	%f0
	lzdr	%f1
	lzdr	%f2
	lzdr	%f3
	lzdr	%f4
	lzdr	%f5
	lzdr	%f6
	lzdr	%f7
	br	%r14
.size	OPENSSL_wipe_cpu,.-OPENSSL_wipe_cpu

.globl	OPENSSL_cleanse
.type	OPENSSL_cleanse,@function
.align	16
OPENSSL_cleanse:
#if !defined(__s390x__) && !defined(__s390x)
	llgfr	%r3,%r3
#endif
	lghi	%r4,15
	lghi	%r0,0
	clgr	%r3,%r4
	jh	.Lot
	clgr	%r3,%r0
	bcr	8,%r14
.Little:
	stc	%r0,0(%r2)
	la	%r2,1(%r2)
	brctg	%r3,.Little
	br	%r14
.align	4
.Lot:	tmll	%r2,7
	jz	.Laligned
	stc	%r0,0(%r2)
	la	%r2,1(%r2)
	brctg	%r3,.Lot
.Laligned:
	srlg	%r4,%r3,3
.Loop:	stg	%r0,0(%r2)
	la	%r2,8(%r2)
	brctg	%r4,.Loop
	lghi	%r4,7
	ngr	%r3,%r4
	jnz	.Little
	br	%r14
.size	OPENSSL_cleanse,.-OPENSSL_cleanse

.globl	OPENSSL_instrument_bus
.type	OPENSSL_instrument_bus,@function
.align	16
OPENSSL_instrument_bus:
	lghi	%r2,0
	br	%r14
.size	OPENSSL_instrument_bus,.-OPENSSL_instrument_bus

.globl	OPENSSL_instrument_bus2
.type	OPENSSL_instrument_bus2,@function
.align	16
OPENSSL_instrument_bus2:
	lghi	%r2,0
	br	%r14
.size	OPENSSL_instrument_bus2,.-OPENSSL_instrument_bus2

.globl	s390x_trng
.type	s390x_trng,@function
.align	16
s390x_trng:
	lghi	%r5,0
	lghi	%r0,114		# prno capability vector checked by caller
	.long	0xb93c0042	# prno %r4,%r2
	brc	1,.-4		# pay attention to "partial completion"
	br	%r14
.size	s390x_trng,.-s390x_trng

.globl	s390x_drng
.type	s390x_drng,@function
.align	16
s390x_drng:
#if !defined(__s390x__) && !defined(__s390x)
	l	%r1,96(%r15)
#else
	lg	%r1,160(%r15)
#endif
	lr	%r0,%r6		# prno capability vector checked by caller
	.long	0xb93c0024	# prno %r2,%r4
	brc	1,.-4		# pay attention to "partial completion"
	br	%r14
.size	s390x_drng,.-s390x_drng

.section	.init
	brasl	%r14,OPENSSL_cpuid_setup

.comm	OPENSSL_s390xcap_P,168,8
